> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-connect/methods/stx_deploycontract.md).

# stx\_deployContract

Requests the connected wallet to sign and broadcast a Clarity smart contract deployment transaction.

***

### Usage

```ts
import { request } from '@stacks/connect';

const result = await request('stx_deployContract', {
  name: 'my-contract',
  clarityCode: `
    (define-public (say-hello)
      (ok "hello world"))
  `,
  clarityVersion: 3,
  network: 'mainnet',
});

console.log('Transaction ID:', result.txid);
```

#### Notes

* The `name` is the contract name that will be used in the contract identifier (e.g. if your address is `SP2...` and name is `my-contract`, the full identifier becomes `SP2....my-contract`).
* If `clarityVersion` is not specified, wallets typically default to the latest supported Clarity version.

[**Reference Link**](https://github.com/stx-labs/connect/blob/main/packages/connect/src/methods.ts#L90)

***

### Signature

```ts
function request(
  'stx_deployContract',
  params: DeployContractParams
): Promise<TransactionResult>
```

***

### Returns

`TransactionResult`

```ts
interface TransactionResult {
  txid?: string;
  transaction?: string;
}
```

| Property      | Type                | Description                                        |
| ------------- | ------------------- | -------------------------------------------------- |
| `txid`        | `string` (optional) | The transaction ID of the broadcasted transaction. |
| `transaction` | `string` (optional) | The raw signed transaction hex.                    |

***

### Parameters

#### name (required)

* **Type**: `string`

The name for the deployed contract. This will be part of the contract's fully qualified identifier.

#### clarityCode (required)

* **Type**: `string`

The Clarity source code of the contract to deploy.

#### clarityVersion (optional)

* **Type**: `number | string`

The Clarity language version to use. Current live versions are `1`, `2`, and `3`. Wallets may not support this parameter yet and typically default to the latest version.

#### address (optional)

* **Type**: `AddressString`

The recommended sender address to use. Wallets may not implement this for privacy reasons.

#### network (optional)

* **Type**: `NetworkString`

The network to use for the transaction (e.g. `'mainnet'`, `'testnet'`, `'devnet'`).

#### fee (optional)

* **Type**: `Integer` (`number | bigint | string`)

A custom fee for the transaction (in microstacks).

#### nonce (optional)

* **Type**: `Integer` (`number | bigint | string`)

A custom nonce for the transaction.

#### sponsored (optional)

* **Type**: `boolean`

Whether the transaction should be sponsored.

#### postConditions (optional)

* **Type**: `(string | PostCondition)[]`

An array of post conditions to attach to the transaction.

#### postConditionMode (optional)

* **Type**: `PostConditionModeName`

The post condition mode: `'allow'` or `'deny'`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-connect/methods/stx_deploycontract.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
